-- settings context menu

function CleanUI_SettingsOnUpdate(self, elapsed)
    if ( not self.showTimer or not self.isCounting ) then
        return;
    elseif ( self.showTimer < 0 ) then
        self:Hide();
        self.showTimer = nil;
        self.isCounting = nil;
    else
        self.showTimer = self.showTimer - elapsed;
    end
end

function CleanUI_SettingsStartAutoHide(frame)
    CUISettingsContextMenu.showTimer = UIDROPDOWNMENU_SHOW_TIME;
    CUISettingsContextMenu.isCounting = 1;
end

function CleanUI_SettingsStopAutoHide(frame)
    CUISettingsContextMenu.isCounting = nil;
end

function CleanUI_ShowContextMenu(parent)
    
    local dropdown = _G["CUISettingsContextMenu"];
    
    if (not dropdown) then
        dropdown = CreateFrame("Frame", "CUISettingsContextMenu", UIParent);
        dropdown:SetFrameStrata("TOOLTIP");

        dropdown:SetSize(175, 80);
        dropdown:SetPoint("BOTTOMRIGHT", parent, "TOPRIGHT", 0, 5);
        CleanUI_SetBackdrop(dropdown, true);
        
        dropdown:SetScript("OnEnter", CleanUI_SettingsStopAutoHide);
        dropdown:SetScript("OnLeave", CleanUI_SettingsStartAutoHide);
        dropdown:SetScript("OnUpdate", CleanUI_SettingsOnUpdate);
        
        -- master volume
    
        dropdown.masterVolume = CreateFrame("Slider", "CUISettingsMasterVolume", dropdown, "CUIConfig_MasterVolumeTemplate");
        
        dropdown.masterVolume:SetSize(130, 17);
        dropdown.masterVolume:SetPoint("BOTTOMLEFT", dropdown, "BOTTOMLEFT", 10, 10);
        
        dropdown.masterVolume:SetScript("OnEnter", CleanUI_SettingsStopAutoHide);
        dropdown.masterVolume:SetScript("OnLeave", CleanUI_SettingsStartAutoHide);
        
        dropdown.masterVolume:SetMinMaxValues(0, 1);
        
        _G["CUISettingsMasterVolumeLow"]:Hide();
        _G["CUISettingsMasterVolumeHigh"]:Hide();
        dropdown.masterVolume.type = CONTROLTYPE_SLIDER;
        dropdown.masterVolume.cvar = "Sound_MasterVolume";
        _G["CUISettingsMasterVolumeText"]:SetFontObject("GameFontNormalSmall");
        _G["CUISettingsMasterVolumeText"]:SetPoint("BOTTOM", self, "TOP", 0, 4);
        
        -- mute checkbutton
        
        dropdown.mute = CreateFrame("CheckButton", "CUISettingsMuteButton", dropdown, "CUIConfig_EnableSoundTemplate");
        
        dropdown.mute:SetSize(20, 20);
        dropdown.mute:SetPoint("BOTTOMLEFT", dropdown.masterVolume, "TOPLEFT", -2, 24);
        
        dropdown.mute:SetScript("OnEnter", CleanUI_SettingsStopAutoHide);
        dropdown.mute:SetScript("OnLeave", CleanUI_SettingsStartAutoHide);
        
        dropdown.mute.type = CONTROLTYPE_CHECKBOX;
        dropdown.mute.cvar = "Sound_EnableAllSound";
    end
    
    CleanUI_SettingsStartAutoHide(dropdown);
    dropdown:Show();
    
    local volume = tonumber(GetCVar("Sound_MasterVolume"));
    dropdown.masterVolume:SetValue(volume);
    
    local enableSound = tonumber(GetCVar("Sound_EnableAllSound"));
    dropdown.mute:SetChecked(enableSound == 1);
                
    -- [alt] + right
    
    --[[ toggles
      x cursor
      x gc
      x latency
    ]]
    --[[ scales
      - unit frames
      - party
      - minimap
      - action bars
    ]]
    
    --[[ volume
      x mute
      - master
      - SFX
      - Music
      - Ambience
      - Dialog
    ]]
end