local oldname = nil;

local equipmentSetItems = nil;

function CleanUI_InitGameMenu()
    CleanUI_GameMenuHookEvents();
    CleanUI_RegisterGameMenu();
    
    CleanUI_UpdateGameMenu();
end

function CleanUI_RegisterGameMenu()
    local frame = CreateFrame("Frame");

    --frame:RegisterEvent("EQUIPMENT_SETS_CHANGED");

    frame:HookScript("OnEvent", CleanUI_GameMenuOnEvent); 
end

function CleanUI_GameMenuOnEvent(self, event, ...)

    --if (event == "EQUIPMENT_SETS_CHANGED") then
    --    CleanUI_UpdateEquipmentSetItems();
    --end
end 

function CleanUI_GameMenuHookEvents()
    hooksecurefunc("GameMenuFrame_UpdateVisibleButtons", CleanUI_GameMenuFrame_UpdateVisibleButtons);
end

function CleanUI_UpdateGameMenu()
    CleanUI_RemoveTextures(GameMenuFrame);
    CleanUI_SetArtBackdrop(GameMenuFrame, 20);

    CleanUI_GameMenuFrame_UpdateVisibleButtons();
end

function CleanUI_GameMenuFrame_UpdateVisibleButtons()
    local height = GameMenuFrame:GetHeight() + 55;
    GameMenuFrame:SetHeight(height);
    
    GameMenuButtonLogout:ClearAllPoints();
    GameMenuButtonLogout:SetPoint("TOP", CleanUIGameMenuButtonReloadUI, "BOTTOM", 0, -10);
    
    if (not GameMenuFrame.info) then
        local title = GetAddOnMetadata("CleanUI", "Title");
        local version = GetAddOnMetadata("CleanUI", "Version");
    
        GameMenuFrame.info = GameMenuFrame:CreateFontString("GameMenuFrameInfo", "ARTWORK");
        GameMenuFrame.info:SetFontObject("CuiFont_ExtraSmall");
        GameMenuFrame.info:SetText("powered by |c333399ff"..title.."|r ("..version..")");
        GameMenuFrame.info:SetJustifyH("CENTER");
        GameMenuFrame.info:SetSize(180, 15);
        GameMenuFrame.info:ClearAllPoints();
        GameMenuFrame.info:SetPoint("BOTTOMLEFT", GameMenuFrame, "BOTTOMLEFT", 0, 4);
        GameMenuFrame.info:SetPoint("BOTTOMRIGHT", GameMenuFrame, "BOTTOMRIGHT", 0, 4);
    end
    
    if (true) then
        return;
    end
    
    -- rearange buttons
    
    GameMenuFrame:SetSize(370, 345);
    
    GameMenuButtonHelp:SetSize(145, 27);  
    GameMenuButtonHelp:ClearAllPoints();
    GameMenuButtonHelp:SetPoint("TOPLEFT", GameMenuFrame, "TOPLEFT", 20, -30); 
    
    GameMenuButtonStore:SetSize(145, 27); 
    GameMenuButtonWhatsNew:SetSize(145, 27); 
    
    if (not GameMenuFrame.settingsLabel) then
        GameMenuFrame.settingsLabel = GameMenuFrame:CreateFontString("GameMenuFrameInfo", "ARTWORK");
        GameMenuFrame.settingsLabel:SetFontObject("GameFontNormal");
        GameMenuFrame.settingsLabel:SetText(SETTINGS);
        GameMenuFrame.settingsLabel:SetJustifyH("LEFT");
        GameMenuFrame.settingsLabel:SetSize(145, 27);
        GameMenuFrame.settingsLabel:ClearAllPoints();
        GameMenuFrame.settingsLabel:SetPoint("TOP", GameMenuButtonWhatsNew, "BOTTOM", 0, -16);
    end
    
    GameMenuButtonOptions:SetSize(145, 27); 
    GameMenuButtonOptions:SetPoint("TOP", GameMenuFrame.settingsLabel, "BOTTOM", 0, -1);
    GameMenuButtonUIOptions:SetSize(145, 27); 
    
    GameMenuButtonKeybindings:ClearAllPoints();
    GameMenuButtonKeybindings:SetPoint("TOP", GameMenuButtonUIOptions, "BOTTOM", 0, -16);
    GameMenuButtonKeybindings:SetSize(145, 27); 
    GameMenuButtonMacros:SetSize(145, 27); 
    GameMenuButtonAddons:SetSize(145, 27); 
    
    CleanUIGameMenuButtonReloadUI:SetSize(145, 27);  
    CleanUIGameMenuButtonReloadUI:ClearAllPoints();
    CleanUIGameMenuButtonReloadUI:SetPoint("TOPRIGHT", GameMenuFrame, "TOPRIGHT", -20, -170); 
    
    GameMenuButtonLogout:SetSize(145, 27); 
    GameMenuButtonLogout:ClearAllPoints();
    GameMenuButtonLogout:SetPoint("TOP", CleanUIGameMenuButtonReloadUI, "BOTTOM", 0, -16);
    GameMenuButtonQuit:SetSize(145, 27); 
    GameMenuButtonContinue:SetSize(145, 27); 
end
