function CleanUI_InitMiniMap()
    CleanUIUserData.scaleMiniMap = CleanUIUserData.scaleMiniMap or 1.1

    CleanUI_MiniMapHookEvents();
    CleanUI_RegisterMiniMapEvents();
    
    CleanUI_ChangeMiniMap();
    CleanUI_ScaleMiniMap();
    
    CleanuUI_ChangeMiniMapArt();
end

function CleanUI_RegisterMiniMapEvents()
    local frame = CreateFrame("Frame");

    frame:RegisterEvent("ADDON_LOADED");
    --frame:RegisterEvent("MERCHANT_SHOW");
    --frame:RegisterEvent("BANKFRAME_OPENED");
    --frame:RegisterEvent("BAG_UPDATE");

    frame:HookScript("OnEvent", CleanUI_MiniMapOnEvent);
    frame:HookScript("OnUpdate", CleanUI_MiniMapOnUpdate);
end

function CleanUI_MiniMapOnEvent(self, event, ...)

    if (event == "ADDON_LOADED") then
        local addonName = ...;
        if ( addonName == "..." ) then
        end
    end

    --if (event == "MERCHANT_SHOW") then
        --CleanUI_MerchantShow();
    --end
end

local UPDATE_WAIT = 0.5;
local _WaitTimeSinceLast = 0;
function CleanUI_MiniMapOnUpdate(self, elapsed)
    if (_WaitTimeSinceLast <= 0) then
        CleanUI_UpdateMiniMapCoords();
        _WaitTimeSinceLast = UPDATE_WAIT;
    else
        _WaitTimeSinceLast = _WaitTimeSinceLast - elapsed;
    end
end

function CleanUI_MiniMapHookEvents()
end

function CleanUI_SetMiniMapScale(scale)
    if (scale and scale >= 0.5 and scale <= 2) then
        CleanUIUserData.scaleMiniMap = scale;
        CleanUI_ScaleMiniMap();
    else
        DEFAULT_CHAT_FRAME:AddMessage("scale: from 0.5 to 2.0", 1.0, 0, 0, 1, 10);
    end
end

function CleanUI_ScaleMiniMap()    
    MinimapCluster:SetScale(CleanUIUserData.scaleMiniMap);
end

function CleanUI_ChangeMiniMap()
    -- Koordinaten
    local coords = Minimap:CreateFontString("CUIWorldMiniMapFrameCoords", "ARTWORK");
    coords:SetFontObject("CuiFont_ExtraSmall");
    coords:SetWidth(Minimap:GetWidth());
    coords:SetHeight(10);
    coords:ClearAllPoints();
    coords:SetPoint("BOTTOMLEFT", Minimap, "BOTTOMLEFT", 0, 0);
    coords:SetPoint("BOTTOMRIGHT", Minimap, "BOTTOMRIGHT", 0, 0);
    coords:SetJustifyH("CENTER");
    coords:SetText("Hallo");
end

function CleanuUI_ChangeMiniMapArt()
    Minimap:SetMaskTexture("Interface\\AddOns\\CleanUI\\skins\\minimap\\masktexture");
    MinimapBorder:Hide();
    MinimapBorderTop:Hide();
    
    Minimap:ClearAllPoints();
    Minimap:SetPoint("TOP", MinimapCluster, "TOP", -5, -25);

    -- no north
    MinimapNorthTag:SetTexture();
    
    -- zone text

    MinimapZoneTextButton:ClearAllPoints();
    MinimapZoneTextButton:SetPoint("TOPLEFT", MinimapCluster, "TOPLEFT", 19, -8);
    MinimapZoneTextButton:SetPoint("BOTTOMRIGHT", MinimapCluster, "TOPRIGHT", -29, -25);
    
    -- world map button
    
    MiniMapWorldMapButton:SetNormalTexture("Interface\\worldmap\\UI-World-Icon");
    MiniMapWorldMapButton:SetPushedTexture("Interface\\worldmap\\UI-World-Icon");
    MiniMapWorldMapButton:SetHighlightTexture("Interface\\worldmap\\UI-World-Icon");
    
    MiniMapWorldMapButton:GetNormalTexture():SetTexCoord(0, 1, 0, 1);
    MiniMapWorldMapButton:GetPushedTexture():SetTexCoord(0, 1, 0, 1);
    MiniMapWorldMapButton:GetHighlightTexture():SetTexCoord(0, 1, 0, 1);
    
    MiniMapWorldMapButton:SetSize(32, 32);
    MiniMapWorldMapButton:SetPoint("TOPRIGHT", -2, 18);
    
    -- game time frame
    
    GameTimeFrame:SetSize(32, 32);
    
    GameTimeFrame:ClearAllPoints();
    GameTimeFrame:SetPoint("TOP", MiniMapWorldMapButton, "BOTTOM", 0, -2);
    
    -- tracking button
    
    MiniMapTracking:SetSize(32, 32);
    
    MiniMapTracking:ClearAllPoints();
    MiniMapTracking:SetPoint("TOP", GameTimeFrame, "BOTTOM", 0, -2);
    
    -- mail frame
    
    MiniMapMailFrame:SetSize(32, 32);
    
    MiniMapMailFrame:ClearAllPoints();
    MiniMapMailFrame:SetPoint("TOP", MiniMapVoiceChatFrame, "BOTTOM", 0, -2);    
    
    -- time manager
    
    TimeManagerClockButton:ClearAllPoints();
    --TimeManagerClockButton:SetPoint("TOP", MinimapCluster, "BOTTOM", -10, 47);
    TimeManagerClockButton:SetPoint("BOTTOMRIGHT", UIParent, "BOTTOMRIGHT", 0, -2.5);

    TimeManagerFrame:ClearAllPoints();
    TimeManagerFrame:SetPoint("BOTTOMRIGHT", UIParent, "BOTTOMRIGHT", -100, 150);
    CleanUI_SetBackdrop(TimeManagerClockButton, true, nil, 0, 5, 2, 0);

    CleanUI_ReplaceTextureWith("ClockBackground", TimeManagerClockButton, nil);
    
    TimeManagerClockButton:SetSize(60, 39);
    
    -- change right click
    TimeManagerClockButton:SetScript("OnClick", CleanUI_TimeManagerClockButton_OnClick);

    TimeManagerClockTicker:SetFontObject(NumberFontNormalLarge)
    
    -- recording button
    
    --MiniMapRecordingButton:ClearAllPoints();
    --MiniMapRecordingButton:SetPoint("LEFT", TimeManagerClockButton, "RIGHT", 0, 0);
    
    -- landing page 
    GarrisonLandingPageMinimapButton:ClearAllPoints();
    GarrisonLandingPageMinimapButton:SetScale(0.75);
    GarrisonLandingPageMinimapButton:SetPoint("TOP", MinimapCluster, "BOTTOMRIGHT", -50, 34);
    
    -- queue status button
    QueueStatusMinimapButton:ClearAllPoints();
    QueueStatusMinimapButton:SetScale(1.2);
    QueueStatusMinimapButton:SetPoint("TOP", MinimapCluster, "BOTTOMLEFT", 20, 22);
    QueueStatusMinimapButtonBorder:Hide();
    
    -- instance difficulty
    MiniMapInstanceDifficulty:SetPoint("TOPLEFT", 18, -20);
    GuildInstanceDifficulty:SetPoint("TOPLEFT", 18, -20);
    MiniMapChallengeMode:SetPoint("TOPLEFT", 24, -25);
    
    -- change icons
    
    WorldMapFrame.BorderFrame.portrait:SetTexture("Interface\\worldmap\\UI-World-Icon");
    MiniMapMailIcon:SetTexture("Interface\\mailframe\\mail-icon");
    
    -- border
    
    local cuiArtFrame = _G["CleanUIMinimapArtFrame"];
    if (not cuiArtFrame) then
        cuiArtFrame = CreateFrame("Frame", "CleanUIMinimapArtFrame", MinimapCluster);
    end

    local cuiArtFrame = CleanUI_SetArtBackdrop(MinimapCluster, -1, 12, 24, -23);
    
    if (not cuiArtFrame.topline) then
        cuiArtFrame.topline = cuiArtFrame:CreateTexture("ARTWORK");
        cuiArtFrame.topline:SetSize(100, 4);
        cuiArtFrame.topline:SetParent(Minimap);
        cuiArtFrame.topline:SetPoint("TOPLEFT", cuiArtFrame, "TOPLEFT", 8, -22);
        cuiArtFrame.topline:SetPoint("TOPRIGHT", cuiArtFrame, "TOPRIGHT", -8, -26);
        cuiArtFrame.topline:SetTexture("Interface\\TradeSkillFrame\\UI-TradeSkill-SkillBorder");
        cuiArtFrame.topline:SetTexCoord(0.1, 1.0, 0.0, 0.25);
    end
end

function CleanUI_UpdateMiniMapCoords()
    local player_x, player_y = CleanUI_GetPlayerMapPosition();
    CUIWorldMiniMapFrameCoords:SetText(player_x.."|cffffffff/|r"..player_y);
end

function CleanUI_TimeManagerClockButton_OnClick(self, button)
    if (button == "LeftButton") then
        TimeManagerClockButton_OnClick(self, button);
        return;
    end
    
    CleanUI_ShowContextMenu(self);
end