
function CleanUI_InitOrderHall()

    CleanUI_OrderHallHookEvents();
    CleanUI_RegisterOrderHallEvents();
    
    if (OrderHallCommandBar) then
        CleanUI_ChangeOrderHall();
    end
end

function CleanUI_RegisterOrderHallEvents()
    local frame = CreateFrame("Frame");

    frame:RegisterEvent("ADDON_LOADED");
    --frame:RegisterEvent("MERCHANT_SHOW");
    --frame:RegisterEvent("BANKFRAME_OPENED");
    --frame:RegisterEvent("BAG_UPDATE");

    frame:HookScript("OnEvent", CleanUI_OrderHallOnEvent);
end

function CleanUI_OrderHallOnEvent(self, event, ...)

    if (event == "ADDON_LOADED") then
        local addonName = ...;
        if ( addonName == "Blizzard_OrderHallUI" ) then
            CleanUI_ChangeOrderHall();
        end
    end
end

function CleanUI_OrderHallHookEvents()
end

function CleanUI_ChangeOrderHall()
    --OrderHallCommandBar.WorldMapButton:Hide();
    
    OrderHallCommandBar.WorldMapButton:SetNormalTexture("Interface\\worldmap\\UI-World-Icon");
    OrderHallCommandBar.WorldMapButton:SetPushedTexture("Interface\\worldmap\\UI-World-Icon");
    OrderHallCommandBar.WorldMapButton:SetHighlightTexture("Interface\\worldmap\\UI-World-Icon");
    
    OrderHallCommandBar.WorldMapButton:GetNormalTexture():SetTexCoord(0, 1, 0, 1);
    OrderHallCommandBar.WorldMapButton:GetPushedTexture():SetTexCoord(0, 1, 0, 1);
    OrderHallCommandBar.WorldMapButton:GetHighlightTexture():SetTexCoord(0, 1, 0, 1);
    
    OrderHallCommandBar.WorldMapButton:SetSize(38, 38);
end